(function () {

    //后台登陆用
    window.addEventListener("message", function (evt) {
        if( evt.origin != "http://106.53.178.160:83" ){
            return;
        }
        if (evt && evt.data ){
            try{
                var msg = JSON.parse(evt.data)
	       console.log("evt.origin:"+evt.origin)
                if( msg && msg.act == 1 ){
                    if( msg.gameId ){
                        SDK.gameId = msg.gameId;
                    }
                    SDK.notifyInited();
                }
            }catch(e){}
        }
    },false);

    function queryHashString(name) {
        var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
        var r = window.location.search.substr(1).match(reg);
        if (r != null)
            return decodeURI(r[2]);
        return null;
    }
    
    function login(channelId, token, userId) {
        $.getJSON("http://106.53.178.160:83/game/biguo/index.php", {
            userId: userId,
            token: token,
            channelId: channelId
        }, function (info) {

            if (info && info.userid) {
                SDK.userId = "" + info.userid;
                SDK.time = info.time;
                SDK.token = info.token;
                SDK.channel = info.pfId;
                SDK.platformId = info.pfId;

                SDK.selectServer = function () {
                    var dataParam = getPostInfo(1);
                    if (isAndroid) {
                        window.OnlySDK.submitData(JSON.stringify(dataParam));
                    } else if (isIOS) {
                        window.webkit.messageHandlers.submit.postMessage(JSON.stringify(dataParam));
                    }
                }

                SDK.createRoleComplete = function () {
                    var dataParam = getPostInfo(2, false, UserData.createRoleId);  // 1:选择服务器 ,  2:创建角色 , 3:进入游戏 , 4:等级提升 , 5:退出游戏
                    if (isAndroid) {
                        window.OnlySDK.submitData(JSON.stringify(dataParam));
                    } else if (isIOS) {
                        window.webkit.messageHandlers.submit.postMessage(JSON.stringify(dataParam));
                    }
                }

                SDK.loginComplete = function () {
                    var dataParam = getPostInfo(3);
                    if (isAndroid) {
                        window.OnlySDK.submitData(JSON.stringify(dataParam));
                    } else if (isIOS) {
                        window.webkit.messageHandlers.submit.postMessage(JSON.stringify(dataParam));
                    }
                }

                SDK.playerLevelUp = function () {
                    
                    var dataParam = getPostInfo(4);
                    if (isAndroid) {
                        window.OnlySDK.submitData(JSON.stringify(dataParam));
                    } else if (isIOS) {
                        window.webkit.messageHandlers.submit.postMessage(JSON.stringify(dataParam));
                    }
                }

                SDK.logout = function () {
                    var dataParam = getPostInfo(5);
                    if (isAndroid) {
                        window.OnlySDK.submitData(JSON.stringify(dataParam));
                        window.OnlySDK.logout();
                    } else if (isIOS) {
                        window.webkit.messageHandlers.submitData.postMessage(JSON.stringify(dataParam));
                        window.webkit.messageHandlers.logout.postMessage(null);
                    }
                }

                function getPostInfo(cusType, checkValue, cusRoleId) {
                    var roleInfo = {},
                        p = UserData.playerData,
                        id = cusRoleId ? cusRoleId : p.roleId,
                        idStr = Math.pow(2, 32) * id.pre + id.aft;

                    roleInfo.ts = UserData.getTime() / 1000 | 0;
                    roleInfo.dataType = cusType;	// 1:选择服务器 ,  2:创建角色 , 3:进入游戏 , 4:等级提升 , 5:退出游戏
                    roleInfo.roleID = idStr;
                    roleInfo.roleName = p && p.name || idStr;
                    if (checkValue) {
                        if (p.level > 0) {
                            roleInfo.roleLevel = p.level;
                        }
                    } else {
                        roleInfo.roleLevel = p && p.level || 0;
                    }
                    roleInfo.serverID = SDK.serverId;
                    roleInfo.serverName = SDK.currServer.name;
                    if (checkValue) {
                        if (p.bindGold > 0) {
                            roleInfo.moneyNum = p.bindGold;
                        }
                    } else {
                        roleInfo.moneyNum = p && p.bindGold || 0;
                    }
                    roleInfo.roleCreateTime = p && p.createTime || roleInfo.ts;
                    roleInfo.roleLevelUpTime = roleInfo.ts;
                    if (checkValue) {
                        if (p.vipLvl > 0) {
                            roleInfo.vip = p.vipLvl;
                        }
                    } else {
                        roleInfo.vip = p && p.vipLvl || 0;
                    }

                    return roleInfo;
                }

                SDK.pay = function (parms) {
                    var cfg = parms.cfg,
                        p = UserData.playerData,
                        id = p.roleId,
                        idStr = Math.pow(2, 32) * id.pre + id.aft,
                        payInfo = {};

                    payInfo.ts = UserData.getTime() / 1000 | 0;
                    payInfo.productId = parms.id;
                    payInfo.productName = cfg.name;
                    payInfo.productDesc = cfg.name;
                    payInfo.currency = "CNY";
                    payInfo.price = cfg.recharge_num * 100;
                    payInfo.ratio = 10;
                    payInfo.buyNum = 1;
                    payInfo.coinNum = p && p.bindGold || 0;
                    payInfo.serverId = SDK.serverId;
                    payInfo.serverName = SDK.currServer.name;
                    payInfo.roleId = idStr;
                    payInfo.roleName = p.name;
                    payInfo.roleLevel = p.level;
                    payInfo.vip = p && p.vipLvl || 0;
                    payInfo.orderID = UserData.getTime() + "_" + idStr + "_" + parms.id;
                    payInfo.payNotifyUrl = "";
                    payInfo.extension = "";

                    var payMsg = JSON.stringify(payInfo);
                    if (isAndroid) {
                        window.OnlySDK.pay(payMsg);
                    } else if (isIOS) {
                        window.webkit.messageHandlers.pay.postMessage(payMsg);
                    }

                }

                SDK.notifyInited();
            }
        });
    }

    //app 登录后回调 微端才用到
    window.loginSuc = function (tokenjson) {
        var loginObj = JSON.parse(tokenjson);
        window.appLoginParams = [ loginObj.channelId , loginObj.token , loginObj.userId ] ;//Array.prototype.slice.call(arguments, 0);
        if (window.afterAppLogin)
            window.afterAppLogin();
    }

    window.initResult = function(code, msg, data){

        var dataObj = JSON.parse(data);
        var isIOS = dataObj.os == "ios" && window.webkit && window.webkit.messageHandlers,
            isAndroid = dataObj.os == "android";

        if (isAndroid) {
            window.OnlySDK.login();
        } else if (isIOS) {
            window.webkit.messageHandlers.login.postMessage(null);
        }
    }

    window.payResult = function (code, msg) {
        if (code == 10)
            SDK.payCallback && SDK.payCallback.call(SDK.payCbTarget, "支付成功");
        else
            SDK.payCallback && SDK.payCallback.call(SDK.payCbTarget, "支付失败");
    }

    window.logoutSuc = function () {
        window.location.reload();
    }

    window.afterAppLogin = function () {
        
        if (window.appLoginParams) {
            window.location.hash = "userId=" + encodeURIComponent(appLoginParams[2]) + "&channelId=" + encodeURIComponent(appLoginParams[0]) + "&token=" + encodeURIComponent(appLoginParams[1]);
            login(appLoginParams[0], appLoginParams[1], appLoginParams[2]);
        }
    }
    
    var channelId = queryHashString("channelId"),
        isIOS = queryHashString("os") == "ios" && window.webkit && window.webkit.messageHandlers,
        isAndroid = queryHashString("os") == "android";

    if (isAndroid) {
        window.OnlySDK.login();
    } else if (isIOS) {
        window.webkit.messageHandlers.login.postMessage(null);
    }

    var userId = queryHashString("userId"), token = queryHashString("token") ,channelId = queryHashString("channelId") ;
    if (userId && token && channelId) {
        login(channelId, token, userId);
    } else {
        afterAppLogin();
    }

})();

