(function () {
	window.App = {
		version: "1.0.21",
		resJsonUrl: "./resource/default.res.json",
		thmJsonUrl: "./resource/default.thm.json",
		remoteUrl: "resource/",
		configUrl: "http://106.53.178.160:9083/config.json",
		mainJsUrl: "main.min_d25b1e0517cedebb61c5f7d58d11466a.js",
		preloadingBgImgUrl: "",
		title: "大主宰",
		logoImgUrl: "./resource/logo/qzsg_qzsg_logo.png",
		loginBgImgUrl: "",
		loginBtnImgUrl: "",
		getAppJsVersion: function () {

		},
		loadConfig: function(callback, target){
			if (SDK.isLocal) {
                App.$.getJSON("http://106.53.178.160:9083/config.json?v="+App.version, null, function (data) {
                    if (data) {
                    	// App.changeConfig(data);
						callback && callback.call(target, data);
                    }
                });
            } else {
                App.$.getJSON(App.configUrl + "?v="+App.version, null, function (cData) {
                    if (cData) {
                        // var key, keys = cData.key,
                        //     value = cData.value,
                        //     keyList, kLen, data = {},
                        //     objs, m, n, result,
                        //     arr, obj, j, k;
                        // for (key in keys) {
                        //     keyList = keys[key];
                        //     kLen = keyList.length;
                        //     if (kLen <= 0)
                        //         continue;
                        //     result = {};
                        //     objs = value[keyList[0]];
                        //     n = objs.length;
                        //     for (m = 0; m < n; m++) {
                        //         arr = objs[m];
                        //         k = arr.length;
                        //         if (k != kLen)
                        //             continue;
                        //         obj = {};
                        //         for (j = 1; j < k; j++) {
                        //             obj[keyList[j]] = arr[j];
                        //         }
                        //         result[arr[0]] = obj;
                        //     }
                        //     data[key] = result;
                        // }
                    	// App.changeConfig(data);
						callback && callback.call(target, cData);
                    }
                });
            }
		},
		apiUrl: "",
		// $: $
	};

	App.$ = window.$ || {
		getJSON: function (url, param, callback) {
			if (typeof param === "function") {
				callback = param;
				param = null;
			}
			if (window.wx)
				wx.request({
					url: url,
					data: param,
					success: callback
				});
			else if ($)
				$.getJSON(url, param, callback);
		}
	};

	window.SDK = {
		gameId: '1', 
		platformId: "",
		urlSeverId: 0,
		serverId: 0,
		userId: '',
		time: 0,
		channel: '',
		token: '',
		servers: [],
		nearServers: [],
		isLocal: false,
		sdkInited: false,
		isCreatePlayer:false,
		log: function (step) {
			App.$.ajax(App.apiUrl + "stat_user_step.php?game_id=" + SDK.gameId + "&user_name=" + SDK.userId + "&channel=" + SDK.channel + "&step=" + step + "&server_id=" + SDK.serverId);
		},
		sendErrorLog: function (errorStr) {
			App.$.ajax(App.apiUrl + "errorlog/error.php?errorStr=" + errorStr + "&user_name=" + SDK.userId + "&channel=" + SDK.channel + "&server_id=" + SDK.serverId);
		},
		getNotice: function (callback) {
			App.$.getJSON(App.apiUrl + "get_game_notice.php?game_id=" + SDK.gameId + "&channel=" + SDK.channel, function (data) {
				callback && callback(data);
			});
		},
		clientIp: '',
		getServerList: function (callback, target) {
			App.$.getJSON(App.apiUrl + "server_config.php?game_id=" + SDK.gameId + "&channel=" + SDK.channel + "&user_name=" + SDK.userId, function (data) {
				var servers, nears;
				if (data instanceof Array) {
					servers = data;
					nears = [];
				} else if (data.server_list) {
					SDK.clientIp = data.client_ip;
					servers = data.server_list;
					nears = data.last_server_list ? data.last_server_list.split(",") : [];
				}

				SDK.servers = servers;
				var obj, i, len = servers.length;
				for (i = 0; i < len; i++) {
					obj = servers[i];
					obj.showId = obj.showId ? parseInt(obj.showId) : (i + 1);
					obj.isNear = obj.isNear == "1";
					obj.isAdvice = obj.isAdvice == "1";
					obj.time = parseInt(obj.time);
					obj.state = parseInt(obj.state);
				}
				if (SDK.urlSeverId) { //链接中指定了服务器
					for (i = 0; i < len; i++) {
						obj = servers[i];
						if (obj.id == SDK.urlSeverId && obj.ip && obj.port) {
							SDK.urlSelectedServer = obj;
							SDK.currServer = obj;
							SDK.serverId = obj.id;
							break;
						}
					}
				}
				if (!SDK.currServer) {
					var f = false;
					for (i = 0; i < len; i++) {
						obj = servers[i];
						if (obj.isNear && obj.ip && obj.port) {
							obj.isAdvice = 1;
							SDK.currServer = obj;
							SDK.serverId = obj.id;
							f = true;
							break;
						}
					}
					if (!f) {
						SDK.isNewUser = true;
						var hasAdvice = false, last, time = -1;
						for (i = 0; i < len; i++) {
							obj = servers[i];
							if (obj.isAdvice) {
								hasAdvice = true;
								SDK.currServer = obj;
								SDK.serverId = obj.id;
								break;
							}
							if (obj.time != undefined && obj.time > time && (obj.state == 1 || obj.state == 2)) {
								last = obj;
								time = obj.time;
							}
						}
						if (!hasAdvice && last) {//推荐最新服
							last.isAdvice = 1;
							SDK.currServer = last;
							SDK.serverId = last.id;
						}
						if (!SDK.currServer && obj) {//全服维护 选最新服
							SDK.currServer = obj;
							SDK.serverId = obj.id;
						}
						SDK.nearServers = nears;
					} else {
						if (nears.length == 0) {
							nears.push(SDK.currServer);
						} else {
							var _i, _len = nears.length;
							for (_i = 0; _i < _len; _i++) {
								for (i = 0; i < len; i++) {
									obj = servers[i];
									if (obj.id == nears[_i]) {
										nears[_i] = obj;
										break;
									}
								}
							}
						}
						SDK.nearServers = nears;
						SDK.isNewUser = false;
					}
				}
				callback && callback.call(target);
			});
		},
		pay: function (params) {
			console.warn('支付接口未被实现！');
		},
		setPayCallback: function (callback, target) {
			SDK.payCallback = callback;
			SDK.payCbTarget = target;
		},
		hasShare: false,
		setShareCallback: function (callback, target) {
			SDK.onShareSuccess = callback;
			SDK.shareCbTarget = target;
		},
		hasFollow: false,
		followStatus: false,
		follow: function (callback) {
			console.warn('关注接口未被实现！');
		},
		setFollowCallback: function (callback, target) {
			SDK.onFollowSuccess = callback;
			SDK.followCbTarget = target;
		},
		hasInvite: false,
		hasShortCut: false,
		shortCut: function () {

		},
		setShortCutCallback: function (callback, target) {
			SDK.onShortCutSuccess = callback;
			SDK.shortCutCbTarget = target;
		},
		hasJoinQQ: false,
		qqLinkSrc: '',
		clientIp: '',
		joinQQ: function () {

		},
		sdkInitedCallback: function () { },
		notifyInited: function () {
			if (SDK.platformId == "soeasy" && (SDK.channel == "letang" || SDK.channel == "xyyou" || App.$.queryString("_hc") == 31))
				SDK.isMailiang = true;
			SDK.sdkInited = true;
			SDK.sdkInitedCallback && SDK.sdkInitedCallback();
			SDK.log(2);
		},
		selectServer: function () {

		},
		createRoleComplete: function () {

		},
		loginComplete: function () {

		},
		playerLevelUp: function () {

		},
		sendInvite: function (params) {
			params.game_id = SDK.gameId;
			App.$.getJSON(App.apiUrl + "invite.php", params);
		},
		isRelease: false
	};

	//app 登录后回调 微端才用到
	window.loginSuc = function () {
		window.appLoginParams = Array.prototype.slice.call(arguments, 0);
		if (window.afterAppLogin)
			window.afterAppLogin();
	}

	function getSdkConfig(sdks) {
		var i, sdk, len = sdks.length;
		for (i = 0; i < len; i++) {
			sdk = sdks[i];
			if (sdk != null && sdk.pfId == SDK.platformId) {
				return sdk;
			}
		}
	}

	$.queryString = function (name, notDecode) {
		var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i");
		var r = window.location.search.substr(1).match(reg);
		if (r != null) {
			if (!notDecode)
				return decodeURIComponent(r[2]);
			return r[2];
		}
	}

	var isWanBa;
	//分享
	(function () {
		var location = window.location,
			host = location.host;
		isWanBa = host.indexOf("urlshare.cn") != -1 && window.getOpenKey && OPEN_DATA;
		//是否本地环境标记
		// SDK.isLocal = host == "localhost" || host.indexOf("192.168") != -1 || host.indexOf("127.0.0.1") != -1;
		//分享处理
		var href = isWanBa ? OPEN_DATA.appurl : (href = location.href, href = href.replace(location.search, ""), href = href.replace(location.hash, "")),
			rootUrl = href.substring(0, href.lastIndexOf("/")) + "/resource/",
			shareList = [{
				title: "老贼，休得猖狂！",
				desc: "本主公开局就是虎威将军子龙，“董卓匹夫，待我取你狗命！”",
				imgUrl: rootUrl + "share_icon1.png"
			}, {
				title: "貂蝉小姐姐约你来战！",
				desc: "天啦噜，臣妾要与主公合体啦，啊哈哈哈！",
				imgUrl: rootUrl + "share_icon2.png"
			}, {
				title: "开局就送白马银枪赵子龙",
				desc: "还有一吕二赵三典韦，四关五马六张飞，尽收归麾下！",
				imgUrl: rootUrl + "share_icon3.png"
			}, {
				title: "主公，请把臣妾带走！！",
				desc: "三国美人齐聚，翘首待与主公合体！",
				imgUrl: rootUrl + "share_icon4.png"
			}, {
				title: "意不意外，惊不惊喜！",
				desc: "首日送红将赵云，3日送红将黄月英，7日送无双战神吕布！",
				imgUrl: rootUrl + "share_icon5.png"
			}, {
				title: "吕狗蛋，听说你1挑3哟？",
				desc: "要是在我枪下你撑得过5秒么！",
				imgUrl: rootUrl + "share_icon6.png"
			}];

		SDK.getShareObj = function () {
			return shareList[Math.random() * shareList.length | 0];
		}
	})();

	function initApiFunc() {

		App.apiUrl = SDK.isRelease ? "http://106.53.178.160:83/www/api/" : "http://106.53.178.160:83/www/api/";
		
		SDK.log(1);
	}

	function getSdkConfig(sdks) {
		var i, sdk, len = sdks.length;
		for (i = 0; i < len; i++) {
			sdk = sdks[i];
			if (sdk != null && sdk.pfId == SDK.platformId) {
				return sdk;
			}
		}
	}

	function initTitleAndThemeByUrlParam() {

		App.preloadingBgImgUrl = "";
		App.title = "大主宰";
		App.logoImgUrl = "./resource/logo/dazhuzai_login_logo.png";
		
	}

	initTitleAndThemeByUrlParam();

	//初始化专服标题 主题
	function initTitleAndThemeByGameId() {
		// if (SDK.gameId == 1) { // 必果互娱 
		// 	App.title = "大主宰";
		// 	App.logoImgUrl = "./resource/logo/qzsg_none_logo.png";
		// }
	}

	function checkIsMaiLiang() {
		SDK.isMailiang = SDK.gameId == 1; 
	}

	function initSDK(sdk) {
		SDK.csInfo = sdk.csInfo;
		initTitleAndThemeByGameId();
		$.getScript(sdk.sdkSrc);
		alert(sdk.sdkSrc)
		if (window.egret)
			egret.log = function () { };
		window.alert = function () { };
		checkIsMaiLiang();
	}

	(function () {

		SDK.platformId = "";

		var info = $.queryString("info");
		if (info) {
			info = JSON.parse(info);
			SDK.platformId = info.pfId;
			SDK.userId = "" + info.userid;
			SDK.time = info.time;
			SDK.token = info.token;
			SDK.channel = info.pfId;
			SDK.extra = info;
		} else {
			var _channel = $.queryString("channelId");
			if (_channel) {
				SDK.platformId = _channel;
				SDK.channel = _channel;
			}
		}

		if ( SDK.platformId != "" ) {


			var otherSdks = [{
					"pfId": "biguo", //必果互娱
					"sdkSrc": "./sdkjs/biguohuyu_sdk.js?v="+App.version,
					"gameId": 1,
					"csInfo": "QQ公众号：800180310"
				}
			];

			sdk = otherSdks[0];//getSdkConfig(otherSdks);
			
			SDK.gameId = sdk.gameId;
			SDK.platformId = sdk.pfId;

			initSDK(sdk);
			 
			SDK.isLocal = false;
			SDK.isRelease = true;
			initApiFunc();
		} else {
			SDK.isLocal = true;
			SDK.time = new Date().getTime() / 1000 | 0;
		
			SDK.channel = "test";
			SDK.csInfo = "QQ群：534943876";
			if (SDK.isLocal) {
				SDK.hasShare = true;
				SDK.hasFollow = true;
				SDK.hasInvite = true;
				SDK.hasJoinQQ = true;
			} else
				SDK.userId = $.queryString("userid") || "";
			initTitleAndThemeByGameId();
			initApiFunc();

			SDK.gameId = 1;//内网分支服用2表示

			SDK.notifyInited();
		}
		
	})();
})();
